# Rex [![Build Status](http://build.rexify.org/buildStatus/icon?job=Master%20branch)](https://build.rexify.org/view/Local%20Tests/job/Master%20branch/)

With (R)?ex you can manage all your boxes from a central point through the complete process of configuration management and software deployment.

## Installation

There are several methods to install (R)?ex: use your distro's package manager, download it from CPAN or build it from source. Check out the [Get Rex](http://www.rexify.org/get/index.html) page on the website for the different options, and choose the one that fits you best.

## Getting started

We have a [Getting started guide](http://www.rexify.org/howtos/start.html) on the website that should help you with the first steps.

## Need help?

If a new user has difficulties to get on board, then it's a bug. Let us know!

Feel free to join us on irc.freenode.net in the #rex channel, ask us on the [Rex Users](https://groups.google.com/group/rex-users/) on Google Groups, or browse and open [issues on GitHub](https://github.com/RexOps/Rex/issues).

If you need commercial support for (R)?ex, check out the [Support](http://www.rexify.org/support/index.html) page on the website.

## Contributing

All contributions are welcome: documentation, patches, bug reports, ideas, promoting (R)?ex at conferences and meetups, or anything else you can think of.

For more details, see the [Help (R)?ex](http://www.rexify.org/contribute/index.html) page on the website.

If you want to contribute new functionality or fix things, you can just clone the repository on GitHub and send pull requests against the *master* branch. We encourage you to logically group your commits together in topic/feature branches and send a pull request for each of your topic branches.

We use perltidy to help us to maintain a consequent code style throughout the project (check out our .perltidyrc for more details). We recommend setting it up with your favorite IDE or text editor, so you can apply formatting easily or even automatically to your changes before committing them.

If you have any questions about how to implement something, join us on irc.freenode.net / #rex.

## Build from source

If you want to build Rex from this source tree, you need to install [Dist::Zilla](https://metacpan.org/pod/Dist::Zilla).

Dist::Zilla comes with the *dzil* command.

To build a .tar.gz release file:
```
dzil build
```

To install rex you can use:
```
dzil install
```

To install the dependencies with *cpanm* you can use:
```
dzil listdeps --missing | cpanm
```

